/*
 * Proyecto: testQwriter
 * Fichero: testQwriterTU.prg
 * Descripcin:
 * Autor:
 * Fecha: 11/03/2020
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

  COMPONENT oVisorPDF
  COMPONENT oBtPrueba
  COMPONENT oNoEdit1
  COMPONENT oMlog
  COMPONENT oBTabrir

  METHOD CreateForm()
  METHOD BtPruebaClick( oSender )
  METHOD FormInitialize( oSender )
  method msg(cMsg)
  METHOD GlassBtn1Click( oSender )

  data oTexto as QWriter
ENDCLASS

#include "testQwriterTU.xfm"

//------------------------------------------------------------------------------
METHOD BtPruebaClick( oSender ) CLASS TForm1

local aData, aTitu, aMatriz, aAnchos
local oTX

::oMlog:lVisible:=.t.


oTX:= QWriter():New(,'QwriterTest.odt',.f.)

if oTX:lValido
  ::msg('Se genero temporal '+oTX:cTemporal)      // Nombre del archivo temporal
  // Reemplazo de texto
  oTX:reemplazar( '[SU NOMBRE]' , 'estimado seor,' )
  oTX:reemplazar( '[DESDE]'     , DToC( Date()-30 ) )
  oTX:reemplazar( '[HASTA]'     , DToC( Date()    ) )

  //-----------------------------------------------------: Insercion Tabla :----
  // Se preparan algunos datos.
  aMatriz:= { {'--','Enero 20','Febrero 20'} , {'Prod 1','5' ,'10'}  ,;
              {'Prod 2','12','8'}            , {'Prod 3','30','15'}    }
  aAnchos:={ 20 ,40 }
  oTX:tabla( 'TABLA' ,aMatriz , aAnchos )           // Se inserta la tabla

  //----------------------------------------------------: Grafico Torta 3d :----
  // Se preparan algunos datos.
  aData:={ {15} , {20} , {45} } ; aTitu:= { 'Prod 1' , 'Prod 2' , 'Prod 3' }
  oTX:graf_Torta3D( 'TORTA3D',aData, aTitu  )
  //------------------------------------------------: Grafico Diagrama X/Y :----
  // Se preparan algunos datos.
  aData:= { {20,30},{01,40},{20,03},{40,03},{03,18},{02,02} }
  aTitu:= {'Costo','Venta'}
  oTX:graf_XY('GRAF_XY',aData, aTitu )
  //-------------------------------------------------------: Grafico Torta :----
  // Se preparan algunos datos.
  //aData:={ {15} , {20} , {45} } ; aTitu:= { 'Prod 1' , 'Prod 2' , 'Prod 3' }
  //oTX:graf_Torta3D( 'TORTA',aData, aTitu  )

  ::msg('Se hicieron reemplazos e incrustaciones')
  oTX:generarPDF()
  if oTX:PDFgenerado
    ::msg('Se genero PDF '+oTX:cTempPDF)

    oTX:mostrarPDF( ::oVisorPDF )
    ::oTexto:=oTX
    ::oBTabrir:lVisible:=.t.
  else
    ::msg('No se genero PDF :(')
  endif
else
  ::msg(oTX:cError)
endif

/*

oTX:mostrarPDF( ::oVisorPDF )
*/

RETURN Nil

//------------------------------------------------------------------------------
method msg(cMsg) CLASS TForm1
::oMlog:Value += cMsg + CRLF
return nil

************************************************************************************************************
function convertToURL( cfilename )
    cfilename := strtran(cfilename,'\','/')
    cfilename := strtran(cfilename,':','|')
    cfilename := strtran(cfilename,' ','%20')
    cfilename := 'file:///'+cfilename
return cfilename

//------------------------------------------------------------------------------
METHOD FormInitialize( oSender ) CLASS TForm1

// Solo para compatibilidad definir dos variables con los paths
AppData:AddData('sy_dbl_path','c:\tr\')
AppData:AddData('sy_ram_path','c:\tr\')

RETURN Nil

//------------------------------------------------------------------------------
METHOD GlassBtn1Click( oSender ) CLASS TForm1
::oTexto:abrirPDF()
RETURN Nil

//------------------------------------------------------------------------------
